package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(ISLASTBuild_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public class ISLASTBuild extends JNIObject  {
	
	/* @generated */
	protected ISLASTBuild(long ptr) {
		/*** PROTECTED REGION ID(ISLASTBuild_Constructor) DISABLED START ***/
		super(ptr);
		/*** PROTECTED REGION END ***/
	}
	
	/* @generated */
	protected static ISLASTBuild build(long ptr) {
		return new ISLASTBuild(ptr);
	}
	
	/*** PROTECTED REGION ID(ISLASTBuild_userCode) ENABLED START ***/
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	/**
	 * isl_ast_build_alloc 
	 * 
	 * @generated
	**/
	 public static ISLASTBuild alloc(ISLContext ctx) { 
		/*** PROTECTED REGION ID(static_isl_ast_build_alloc) DISABLED START ***/
		ISLASTBuild res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLASTBuild.build(ISLNative.isl_ast_build_alloc(getNativePtr(ctx)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_build_from_context 
	 * 
	@take set
	 * @generated
	**/
	 public static ISLASTBuild buildFromContext(ISLSet set) { 
		/*** PROTECTED REGION ID(static_isl_ast_build_from_context) DISABLED START ***/
		ISLASTBuild res;
		
		synchronized(LOCK) {
			checkParameters(set);
			try {
				res = ISLASTBuild.build(ISLNative.isl_ast_build_from_context(getNativePtr(set)));
			} finally {
				taken(set);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_options_set_ast_build_atomic_upper_bound 
	 * 
	 * @generated
	**/
	 public static int setAtomicUpperBound(ISLContext ctx, int val) { 
		/*** PROTECTED REGION ID(static_isl_options_set_ast_build_atomic_upper_bound) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_options_set_ast_build_atomic_upper_bound(getNativePtr(ctx), val);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_options_get_ast_build_atomic_upper_bound 
	 * 
	 * @generated
	**/
	 public static int getAtomicUpperBound(ISLContext ctx) { 
		/*** PROTECTED REGION ID(static_isl_options_get_ast_build_atomic_upper_bound) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_options_get_ast_build_atomic_upper_bound(getNativePtr(ctx));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_options_set_ast_build_prefer_pdiv 
	 * 
	 * @generated
	**/
	 public static int setPreferPDiv(ISLContext ctx, int val) { 
		/*** PROTECTED REGION ID(static_isl_options_set_ast_build_prefer_pdiv) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_options_set_ast_build_prefer_pdiv(getNativePtr(ctx), val);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_options_get_ast_build_prefer_pdiv 
	 * 
	 * @generated
	**/
	 public static int getPreferPDiv(ISLContext ctx) { 
		/*** PROTECTED REGION ID(static_isl_options_get_ast_build_prefer_pdiv) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_options_get_ast_build_prefer_pdiv(getNativePtr(ctx));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_options_set_ast_build_detect_min_max 
	 * 
	 * @generated
	**/
	 public static int setDetectMinMax(ISLContext ctx, int val) { 
		/*** PROTECTED REGION ID(static_isl_options_set_ast_build_detect_min_max) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_options_set_ast_build_detect_min_max(getNativePtr(ctx), val);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_options_get_ast_build_detect_min_max 
	 * 
	 * @generated
	**/
	 public static int getDetectMinMax(ISLContext ctx) { 
		/*** PROTECTED REGION ID(static_isl_options_get_ast_build_detect_min_max) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_options_get_ast_build_detect_min_max(getNativePtr(ctx));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_options_set_ast_build_exploit_nested_bounds 
	 * 
	 * @generated
	**/
	 public static int setExploitNestedBounds(ISLContext ctx, int val) { 
		/*** PROTECTED REGION ID(static_isl_options_set_ast_build_exploit_nested_bounds) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_options_set_ast_build_exploit_nested_bounds(getNativePtr(ctx), val);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_options_get_ast_build_exploit_nested_bounds 
	 * 
	 * @generated
	**/
	 public static int getExploitNestedBounds(ISLContext ctx) { 
		/*** PROTECTED REGION ID(static_isl_options_get_ast_build_exploit_nested_bounds) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_options_get_ast_build_exploit_nested_bounds(getNativePtr(ctx));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_options_set_ast_build_group_coscheduled 
	 * 
	 * @generated
	**/
	 public static int setASTBuildGroupCoscheduled(ISLContext ctx, int val) { 
		/*** PROTECTED REGION ID(static_isl_options_set_ast_build_group_coscheduled) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_options_set_ast_build_group_coscheduled(getNativePtr(ctx), val);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_options_get_ast_build_group_coscheduled 
	 * 
	 * @generated
	**/
	 public static int getASTBuildGroupCoscheduled(ISLContext ctx) { 
		/*** PROTECTED REGION ID(static_isl_options_get_ast_build_group_coscheduled) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_options_get_ast_build_group_coscheduled(getNativePtr(ctx));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_options_set_ast_build_separation_bounds 
	 * 
	 * @generated
	**/
	 public static int setSeparationBounds(ISLContext ctx, int val) { 
		/*** PROTECTED REGION ID(static_isl_options_set_ast_build_separation_bounds) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_options_set_ast_build_separation_bounds(getNativePtr(ctx), val);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_options_get_ast_build_separation_bounds 
	 * 
	 * @generated
	**/
	 public static int getSeparationBounds(ISLContext ctx) { 
		/*** PROTECTED REGION ID(static_isl_options_get_ast_build_separation_bounds) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_options_get_ast_build_separation_bounds(getNativePtr(ctx));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_options_set_ast_build_scale_strides 
	 * 
	 * @generated
	**/
	 public static int setScaleStrides(ISLContext ctx, int val) { 
		/*** PROTECTED REGION ID(static_isl_options_set_ast_build_scale_strides) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_options_set_ast_build_scale_strides(getNativePtr(ctx), val);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_options_get_ast_build_scale_strides 
	 * 
	 * @generated
	**/
	 public static int getScaleStrides(ISLContext ctx) { 
		/*** PROTECTED REGION ID(static_isl_options_get_ast_build_scale_strides) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_options_get_ast_build_scale_strides(getNativePtr(ctx));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_options_set_ast_build_allow_else 
	 * 
	 * @generated
	**/
	 public static int setAllowElse(ISLContext ctx, int val) { 
		/*** PROTECTED REGION ID(static_isl_options_set_ast_build_allow_else) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_options_set_ast_build_allow_else(getNativePtr(ctx), val);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_options_get_ast_build_allow_else 
	 * 
	 * @generated
	**/
	 public static int getAllowElse(ISLContext ctx) { 
		/*** PROTECTED REGION ID(static_isl_options_get_ast_build_allow_else) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_options_get_ast_build_allow_else(getNativePtr(ctx));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_options_set_ast_build_allow_or 
	 * 
	 * @generated
	**/
	 public static int setAllowOr(ISLContext ctx, int val) { 
		/*** PROTECTED REGION ID(static_isl_options_set_ast_build_allow_or) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_options_set_ast_build_allow_or(getNativePtr(ctx), val);
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_options_get_ast_build_allow_or 
	 * 
	 * @generated
	**/
	 public static int getAllowOr(ISLContext ctx) { 
		/*** PROTECTED REGION ID(static_isl_options_get_ast_build_allow_or) DISABLED START ***/
		int res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLNative.isl_options_get_ast_build_allow_or(getNativePtr(ctx));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	/*************************************** 
	 *	         Member Methods            * 
	 ***************************************/
	/**
	 * isl_ast_build_get_ctx 
	 * 
	 * @generated
	**/
	public ISLContext getContext() {
		/*** PROTECTED REGION ID(isl_ast_build_get_ctx) DISABLED START ***/
		ISLContext res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLContext.build(ISLNative.isl_ast_build_get_ctx(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_build_copy 
	 * 
	 * @generated
	**/
	public ISLASTBuild copy() {
		/*** PROTECTED REGION ID(isl_ast_build_copy) DISABLED START ***/
		ISLASTBuild res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLASTBuild.build(ISLNative.isl_ast_build_copy(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_build_free 
	 * 
	 * @take this
	 * @generated
	**/
	public void free() {
		/*** PROTECTED REGION ID(isl_ast_build_free) DISABLED START ***/
		
		synchronized(LOCK) {
			checkParameters(this);
			try {
				ISLNative.isl_ast_build_free(getNativePtr(this));
			} finally {
				taken(this);
			}
		}
		
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_build_expr_from_set 
	 * 
	 * @take set
	 * @generated
	**/
	public ISLASTExpression buildASTExprEvalSet(ISLSet set) {
		/*** PROTECTED REGION ID(isl_ast_build_expr_from_set) DISABLED START ***/
		ISLASTExpression res;
		
		synchronized(LOCK) {
			checkParameters(set);
			try {
				res = ISLASTExpression.build(ISLNative.isl_ast_build_expr_from_set(getNativePtr(this), getNativePtr(set)));
			} finally {
				taken(set);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_build_expr_from_pw_aff 
	 * 
	 * @take pa
	 * @generated
	**/
	public ISLASTExpression buildASTExprEvalPWAff(ISLPWAff pa) {
		/*** PROTECTED REGION ID(isl_ast_build_expr_from_pw_aff) DISABLED START ***/
		ISLASTExpression res;
		
		synchronized(LOCK) {
			checkParameters(pa);
			try {
				res = ISLASTExpression.build(ISLNative.isl_ast_build_expr_from_pw_aff(getNativePtr(this), getNativePtr(pa)));
			} finally {
				taken(pa);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_build_access_from_pw_multi_aff 
	 * 
	 * @take pma
	 * @generated
	**/
	public ISLASTExpression buildASTOpAccess(ISLPWMultiAff pma) {
		/*** PROTECTED REGION ID(isl_ast_build_access_from_pw_multi_aff) DISABLED START ***/
		ISLASTExpression res;
		
		synchronized(LOCK) {
			checkParameters(pma);
			try {
				res = ISLASTExpression.build(ISLNative.isl_ast_build_access_from_pw_multi_aff(getNativePtr(this), getNativePtr(pma)));
			} finally {
				taken(pma);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_build_access_from_multi_pw_aff 
	 * 
	 * @take mpa
	 * @generated
	**/
	public ISLASTExpression buildASTOpAccess(ISLMultiPWAff mpa) {
		/*** PROTECTED REGION ID(isl_ast_build_access_from_multi_pw_aff) DISABLED START ***/
		ISLASTExpression res;
		
		synchronized(LOCK) {
			checkParameters(mpa);
			try {
				res = ISLASTExpression.build(ISLNative.isl_ast_build_access_from_multi_pw_aff(getNativePtr(this), getNativePtr(mpa)));
			} finally {
				taken(mpa);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_build_call_from_pw_multi_aff 
	 * 
	 * @take pma
	 * @generated
	**/
	public ISLASTExpression buildASTOpCall(ISLPWMultiAff pma) {
		/*** PROTECTED REGION ID(isl_ast_build_call_from_pw_multi_aff) DISABLED START ***/
		ISLASTExpression res;
		
		synchronized(LOCK) {
			checkParameters(pma);
			try {
				res = ISLASTExpression.build(ISLNative.isl_ast_build_call_from_pw_multi_aff(getNativePtr(this), getNativePtr(pma)));
			} finally {
				taken(pma);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_build_call_from_multi_pw_aff 
	 * 
	 * @take mpa
	 * @generated
	**/
	public ISLASTExpression buildASTOpCall(ISLMultiPWAff mpa) {
		/*** PROTECTED REGION ID(isl_ast_build_call_from_multi_pw_aff) DISABLED START ***/
		ISLASTExpression res;
		
		synchronized(LOCK) {
			checkParameters(mpa);
			try {
				res = ISLASTExpression.build(ISLNative.isl_ast_build_call_from_multi_pw_aff(getNativePtr(this), getNativePtr(mpa)));
			} finally {
				taken(mpa);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_build_set_options 
	 * 
	 * @take this opts
	 * @generated
	**/
	public ISLASTBuild setOptions(ISLUnionMap opts) {
		/*** PROTECTED REGION ID(isl_ast_build_set_options) DISABLED START ***/
		ISLASTBuild res;
		
		synchronized(LOCK) {
			checkParameters(this, opts);
			try {
				res = ISLASTBuild.build(ISLNative.isl_ast_build_set_options(getNativePtr(this), getNativePtr(opts)));
			} finally {
				taken(this);
				taken(opts);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_build_get_schedule 
	 * 
	 * @generated
	**/
	public ISLUnionMap getSchedule() {
		/*** PROTECTED REGION ID(isl_ast_build_get_schedule) DISABLED START ***/
		ISLUnionMap res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLUnionMap.build(ISLNative.isl_ast_build_get_schedule(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_build_get_schedule_space 
	 * 
	 * @generated
	**/
	public ISLSpace getScheduleSpace() {
		/*** PROTECTED REGION ID(isl_ast_build_get_schedule_space) DISABLED START ***/
		ISLSpace res;
		
		synchronized(LOCK) {
			checkParameters();
			try {
				res = ISLSpace.build(ISLNative.isl_ast_build_get_schedule_space(getNativePtr(this)));
			} finally {
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_build_restrict 
	 * 
	 * @take this set
	 * @generated
	**/
	public ISLASTBuild restrict(ISLSet set) {
		/*** PROTECTED REGION ID(isl_ast_build_restrict) DISABLED START ***/
		ISLASTBuild res;
		
		synchronized(LOCK) {
			checkParameters(this, set);
			try {
				res = ISLASTBuild.build(ISLNative.isl_ast_build_restrict(getNativePtr(this), getNativePtr(set)));
			} finally {
				taken(this);
				taken(set);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_build_set_iterators 
	 * 
	 * @take this iterators
	 * @generated
	**/
	public ISLASTBuild setIterators(ISLIdentifierList iterators) {
		/*** PROTECTED REGION ID(isl_ast_build_set_iterators) DISABLED START ***/
		ISLASTBuild res;
		
		synchronized(LOCK) {
			checkParameters(this, iterators);
			try {
				res = ISLASTBuild.build(ISLNative.isl_ast_build_set_iterators(getNativePtr(this), getNativePtr(iterators)));
			} finally {
				taken(this);
				taken(iterators);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_build_node_from_schedule_map 
	 * 
	 * @take schedule
	 * @generated
	**/
	public ISLASTNode generate(ISLUnionMap schedule) {
		/*** PROTECTED REGION ID(isl_ast_build_node_from_schedule_map) DISABLED START ***/
		ISLASTNode res;
		
		synchronized(LOCK) {
			checkParameters(schedule);
			try {
				res = ISLASTNode.build(ISLNative.isl_ast_build_node_from_schedule_map(getNativePtr(this), getNativePtr(schedule)));
			} finally {
				taken(schedule);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_build_node_from_schedule 
	 * 
	 * @take schedule
	 * @generated
	**/
	public ISLASTNode generate(ISLSchedule schedule) {
		/*** PROTECTED REGION ID(isl_ast_build_node_from_schedule) DISABLED START ***/
		ISLASTNode res;
		
		synchronized(LOCK) {
			checkParameters(schedule);
			try {
				res = ISLASTNode.build(ISLNative.isl_ast_build_node_from_schedule(getNativePtr(this), getNativePtr(schedule)));
			} finally {
				taken(schedule);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_build_node_from_schedule_map_EX 
	 * 
	 * @take schedule
	 * @generated
	**/
	public ISLASTNode generateWithExpansionNodes(ISLUnionMap schedule, String exName) {
		/*** PROTECTED REGION ID(isl_ast_build_node_from_schedule_map_EX) DISABLED START ***/
		ISLASTNode res;
		
		synchronized(LOCK) {
			checkParameters(schedule);
			try {
				res = ISLASTNode.build(ISLNative.isl_ast_build_node_from_schedule_map_EX(getNativePtr(this), getNativePtr(schedule), exName));
			} finally {
				taken(schedule);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	/**
	 * isl_ast_build_node_from_schedule_EX 
	 * 
	 * @take schedule
	 * @generated
	**/
	public ISLASTNode generateWithExpansionNodes(ISLSchedule schedule, String exName) {
		/*** PROTECTED REGION ID(isl_ast_build_node_from_schedule_EX) DISABLED START ***/
		ISLASTNode res;
		
		synchronized(LOCK) {
			checkParameters(schedule);
			try {
				res = ISLASTNode.build(ISLNative.isl_ast_build_node_from_schedule_EX(getNativePtr(this), getNativePtr(schedule), exName));
			} finally {
				taken(schedule);
			}
		}
		
		return res;
		/*** PROTECTED REGION END ***/
	}
	
	
	public String toString() {
		/*** PROTECTED REGION ID(ISLASTBuild_toString) DISABLED START ***/
			return ISLPrettyPrinter.asString(this);
		/*** PROTECTED REGION END ***/
	}
}
